;* Title		: AIRINC429 - RS232 converter
;* Version		: 0
;* Last updated : Nov 09 2005 
;* Target		: tiny2313
;* Author(s)		: AlexRayne@hotbox.ru
;* last Filename	: 
;* initial File		: 
;*
;* This Code is free for private, noncommercial use only
;*
;* DESCRIPTION
;* NOTE 1
;* HISTORY
;* V3.26 2007/06/06 (AlexRayne : AlexRainPE196@newmail.ru)
 
;***************************************************************************

;**** includes ****

.include "tn2313def.inc"

;***************************************************************************
;*
;* CONSTANTES
;*
;***************************************************************************

;**** Constant declarations Data Rate ****

;******** Chrystals for maximum Baudrates
.equ	XTAL = 18432		; XTAL frequency, Khz (7.3728 Mhz)
;********
.equ	BAUD = 115200		; Data rate, bauds
.equ	N = 10				; for 18.432 Mhz/115.200Baud
;********
;.equ	BAUD = 115200		; Data rate, bauds
;.equ	N = 3				; for 7.3728 Mhz/115.200Baud
;********
;.equ	BAUD = 38400		; Data rate, bauds
;.equ	N = 11				; for 7.3728 Mhz/38.400Baud
;********
;.equ	BAUD = 19200		; Data rate, bauds
;.equ	N = 23				; for 7.3728 Mhz/19.200 Baud
;*********

;**** definitions for different chrystals and 115.200 baud ****
;.equ	XTAL = 3686			; XTAL frequency, Khz (3.6864 Mhz)
;*********
;.equ	BAUD = 115200		; Data rate, bauds
;.equ	N = 1				; for 3.6864 Mhz/115.200Baud
;*********
;
;********* Baudrates for 8 Mhz Chrystal
;.equ	XTAL = 8000			; XTAL frequency, Khz (8.000 Mhz)
;*********
;.equ	BAUD = 38400		; Data rate, bauds
;.equ	N = 12				; for 8.00 Mhz/38.400 Baud
;*********
;.equ	BAUD = 19200		;Data rate, bauds
;.equ	N = 25				; for 8.00 Mhz/19.200 Baud
;*********
;.equ	BAUD = 9600			; Data rate, bauds ! Not valid for AVRProg, use for avrdude only !
;.equ	N = 51				; for 8.00 Mhz/9.600 Baud
;*********

;********* Baudrates for 4 Mhz Chrystal
;.equ	XTAL = 4000			; XTAL frequency, Khz (4.000 Mhz)
;*********
;.equ	BAUD = 19200		; Data rate, bauds
;.equ	N = 12				; for 4.00 Mhz/19.200 Baud
;*********
;.equ	BAUD = 9600			; Data rate, bauds ! Not valid for AVRProg, use for avrdude only !
;.equ	N = 25				; for 4.00 Mhz/9.600 Baud
;*********

.equ DelayTick = 1			; mean 1ms delay tick duration

.equ RAMSTART = SRAM_START	;0x60		; first SRAM Adress of 2313
.equ RXBUFSIZE  = 0x30		; 48 bytes internal RAM for Buffer
.equ RXBUFSTART = SRAM_START
.equ RXBUFEND   = RXBUFSTART + RXBUFSIZE -1
.equ TXBUFSIZE  = 0x10		; 48 bytes internal RAM for Buffer
.equ TXBUFSTART = RXBUFEND
.equ TXBUFEND   = TXBUFSTART + TXBUFSIZE


;***************************************************************************
;*
;* PORTS
;*	Ports Definitions
;*
;* DESCRIPTION
;*	Change the following definitions if the RESET pin to the
;*	target moves and/or if the SCK/MISO/MISO/LED moves.
;*
;***************************************************************************

.equ    TEST_PORT=PORTD
.equ    TEST_PIN=PD3
.equ    TESTOUT_SYNC = 0

.equ	PROGPORT= PORTB		; this port used 4 programm spi if
.equ	LEDH	= PB3		; dual color LED output, anode green  (output)
.equ	LED		= PB0		; LED output, active low, dual color LED Kathode green  (output)
.equ	RESET	= PB4		; RESET pin of the target (output)

.equ	SCK		= PB7		; SCK   pin of the target (output)
.equ	MISO	= PB6		; MISO  pin of the target (input)
.equ	MOSI	= PB5		; MOSI  pin of the target (output)

.equ	AOPORT  = PORTB		; this port used 4 programm spi if
.equ    AODATDDR= DDRB
.equ    AODATA  = PB0       ; port for data airinc output


.equ    AOCLKDDR= DDRD
.equ    AOCLK   = PD5       ; OCR0B port - use as clk for airinc output

.equ    AIN_plus= PD2       ; int0 pin
;.equ    AIN_minus= PD3      ; int1 pin

.equ    UARTPORT= PORTD
.equ    UARTDDR= DDRD
.equ	RXD		= PD0		; UART RXD line
.equ	TXD		= PD1		; UART TXD line
.equ	RTS		= PD3		; UART RTS line (out)
.equ	CTS		= PD4		; UART CTS line (in)

;***************************************************************************
;*
;* MACROS
;*	Program Macros
;*
;* DESCRIPTION
;*	Change the following macros if the RESET pin to the
;*	target moves and/or if the SCK/MISO/MISO/LED moves.
;*
;***************************************************************************

;***************************************************************************
;*
;* Global Register Variables
;*
;***************************************************************************
.def    zero        = r1    ; here = 0 value

.def    atx_timermode = r2
.def    atx_period    = r3
.def    atx_pw        = r4
.def	atx_data	  = r5

.def    TXtmp       = r8    ; this regs used by RX\TX ISR internal purposes
.def    RXtmp       = r9

.def    rx_data     = r10   ; this regs used as parameters/result for getc/putc functions
.def    tx_data     = r11   ;

.def    tx_framecnt = r12   ;

.def    arx_periodL = r14   ; used by ICP ISR
.def    arx_periodH = r15

.def    OpFlags     = r16  ;
.equ    fTXFull     = 0;
.equ    fRXFull     = 1;

.def    atx_framecnt= r17
.def    atx_bitcnt  = r18
;.def    atx_temp    = r19
.def    usi_framecnt= r19

.def	temp1		= r20

.def    rx_framecnt = r21   ; counter and flags for RX buffer frame

.def	TXReadFrame = r22	; ptr to frame start byte in TXbuffer
.def	RXWriteFrame= r23	; ptr to frame start byte in RXbuffer
.def	RXWritePtr	= r24	; 
.def	TXReadPtr	= r25	; Low order byte of ReadPtr to UART TXBuffer

.def	ReadPtr	    = r26	; Low order byte of ReadPtr to UART RXBuffer, used olse for acces to TXBuffer
;r26,r27 used as X register used as readPtr to UART RX buffer
.def	RXReadPtr	= r28	; Low order byte of ReadPtr to UART TXBuffer
;Y used as writePtr to UART RXbuffer by UART ISR
.def	TXWritePtr	= r30	; Low order byte of ReadPtr to UART TXBuffer
;r30,r31 used as Z register ; used 4 writePtr on UART TXBuffer

;***************************************************************************
;*
;* Interrupt Vectors
;*
;***************************************************************************

.CSEG
	rjmp	INIT			; Reset Handle

.ORG ICP1addr
    rjmp ICP1_ISR
;.ORG OC1addr
;	rjmp	OC1ISR

.ORG URXCaddr
	rjmp	URXISR

.ORG UDRE0addr
	rjmp	UTXISR

.ORG OC0Baddr
    rjmp    ATX_ISR

.ORG USI_STARTaddr
    rjmp USISTART_ISR

.ORG USI_OVFaddr
;    rjmp    USI_ISR

USI_ISR:
    cli
    in tx_data, USIDR
    sbi USISR, USIOIF       ; release interrupt
    sei
    rcall putc
    inc usi_framecnt
    cpi usi_framecnt, 4
    brlo usi_done
;    cli
;    mov XL, TXReadFrame
;    st X, usi_framecnt
;    sei
    clr usi_framecnt
    mov TXReadFrame, TXWritePtr
    tst tx_framecnt
    brmi UTX_start
usi_done:    
    reti
UTX_start:
;    sbis UCR, UDRE
    cli                 ; enable interupt after reti
    sbi UCR, UDRIE
    reti

USISTART_ISR:
    ; here start the ICP PW mesuring
    cli
;   suppose tcnt1 alredy     
;    out TCNT1H, zero
;    out TCNT1L, zero
    push temp1
    ; start timer1 in normal mode and allow ICP on rise
    ldi temp1, (1 << CS10 | 1 << ICES1)
    out TCCR1A, temp1
    pop temp1
    sei
    ???
    reti
    
ICP1_ISR:
    ; calc pulse pause limit as PW*2
    in arx_periodL, ICR1L
    in arx_periodH, ICR1H
    
    ???
    reti
    
URXISR:
    in	RXtmp,UDR			; Read byte from the UART
    cli
    mov XL, RXWritePtr
	st  X, RXtmp			; store data to SRAM
    sei
    inc RXWritePtr
	cpi	RXWritePtr, RXBUFEND+1
	brlo URX_cko
;	cbi UCR, RXCIE
    ldi RXWritePtr, RXBUFSTART
URX_cko:
	cp	RXWritePtr, YL
    breq URXIntBufferFULL
    ; now check framing
    inc rx_framecnt
    cpi rx_framecnt, 4
    brlo URXIntExit
;    cli
;    mov XL, RXWriteFrame
;    st X, rx_framecnt
;    sei
    mov RXWriteFrame, RXWritePtr
    ; now check and start airinc tx task
	tst atx_framecnt
	brmi URX_startATX
URXIntExit:
	reti
URX_startATX:
	rcall atx_start
	reti	

URXIntBufferFULL:
    cbi UARTPORT, RTS
;    mov RXWritePtr, XL
;    sbr opFlags, fRXfull
    reti

UTXISR:    
    cp  TXReadPtr, ZL
    sbrs opFlags, fTXfull
    breq UTXIntBufferEMPTY
    dec TXReadPtr
    cpi TXReadPtr, TXBUFSTART
    brlo UTX_cko
    ldi TXReadPtr, TXBUFEND
UTX_cko:    
    cli
    mov XL, TXReadPtr
	ld  TXtmp, X			; store data to SRAM
    sei
    out UDR, TXtmp
UTXIntExit:
    cbr opFlags, fTXfull
reti

UTXIntBufferEMPTY:
    ; turn off UTX
    cbi UCR, UDRIE
    reti
    
UTXIntBufferOver:
    ldi TXReadPtr, TXBUFSTART
	reti

;***************************************************************************
;*
;* FUNCTION
;*	getc
;*
;* DESCRIPTION
;*	get char from RX buffer, no checks are supposed
;*  result: rx_data
;* use: 
;*
;***************************************************************************
.macro isURXEmpty
	cp	RXWriteFrame, RXReadPtr
;	cpc XH, YH				; there is no need to compare values more then RAMEND
.endm    
    
getc:
	ld	rx_data, Y+
    sbi UARTPORT, RTS
	cpi	YL, RXBUFEND+1
    brsh RXBUFOver
	ret
RXBUFOver:
    ldi YL, RXBUFSTART
    ret

;***************************************************************************
;*
;* FUNCTION
;*	putc
;*
;* DESCRIPTION
;*	Send a character on the UART Tx line.
;*  result: 
;* use: tx_data - data to send
;*
;***************************************************************************
putc:
	cp	TXWritePtr, TXReadPtr
    breq putc_starttx
putc_buf:    
    cli
    mov XL, TXWritePtr
    dec XL
	cpi	XL, TXBUFSTART
	brlo putc_cko
    ldi XL, TXBUFEND
putc_cko:
	cp	XL, ZL
    breq putc_BufferFULL
	st  X, tx_data			; store data to SRAM
    mov TXWritePtr, XL
    
putc_BufferFULL:
    sei
;	cbi UCR, RXCIE
	ret

putc_starttx:
    sbis USR, UDRE     ; if UDRin process then buffer char
    rjmp putc_buf
    out UDR, tx_data
    sbi UCR, UDRIE      ; turn on UTX
    ret

InitUARTBuffer4cmd:
InitUARTBuffer:
	; load buffer pointer to read
	cli
	; load buffer pointer to load from uart 
	clr YH
	ldi YL, RXBUFSTART		; set Y pointer to SRAM begin
	clr ZH
	ldi ZL, TXBUFEND		; set Z pointer to SRAM begin
	mov TXReadPtr, ZL
	mov RXWritePtr, YL
	mov RXWriteFrame, YL
	sei
	ret

;**********************************************************************************
;*                           airinc transmiter sources
;**********************************************************************************

.equ bytes_per_frame    = 4
.equ frame_pause_tacts  = 4
.equ A100K_PERIOD_MODE	= (1 << WGM02 | 1 << CS00)
.equ A50K_PERIOD_MODE	= (1 << WGM02 | 1 << CS01)
.equ A100K_PERIOD_VALUE  = ((XTAL + 50) / 100)
.equ A96K_PERIOD_VALUE   = ((XTAL + 48) / 96)
.equ A48K_PERIOD_VALUE   = ((XTAL/8 + 24) / 48)
.equ A12K_PERIOD_VALUE   = ((XTAL/8 + 6) / 12)

.macro set_atx_100K
    push temp1
	ldi temp1, A100K_PERIOD_VALUE
	mov atx_period, temp1
	out OCR0A, atx_period
	mov atx_pw, atx_period
	lsr atx_pw
	out OCR0B, atx_pw
	ldi temp1, A100K_PERIOD_MODE
	mov atx_timermode, temp1
	pop temp1
.endm

atx_start:
    isURXEmpty
    breq atx_off
    rcall getc
    ldi atx_framecnt, bytes_per_frame
    
    rcall atx_startbyte
    ; now start timer0 for airinc oputput
;    out OCR0A, atx_period
;    out OCR0B, atx_PW
	out TCNT0, atx_period
    out TCCR0B, atx_timermode
atx_done:
    ret

atx_off:    
    out TCCR0B, zero ; turn off timer0 if no frames to send
    ret
    
atx_startbyte:    
    mov atx_data, rx_data
    ldi atx_bitcnt, 8
    rcall atx_bitset

    ; prepare next byte
atx_preload:    
    cpi atx_framecnt, 2 ; if at frame pause - do not preload next byte
    brlo atx_done
    rcall getc
    ret

atx_bitset:
    cli
    sbrc atx_data, 0
    sbi AOPORT, AODATA
    sbrs atx_data, 0
    cbi AOPORT, AODATA
    sei
    lsr atx_data
    dec atx_bitcnt
    breq atx_nextbyte
    brmi atx_start
    ret

atx_nextbyte:
    dec atx_framecnt
    breq atx_framepause
    brmi atx_start
;    brpl atx_startbyte   ; if counter > 0 then data bytes transive, else frame pause done and lets try start next frame

    mov atx_data, rx_data
    ldi atx_bitcnt, 8
    rjmp atx_preload
;    ret
  

atx_framepause:
    clr  atx_data
    ldi atx_bitcnt, frame_pause_tacts
atx_prepareframe:
    isURXEmpty
    breq atx_done
    rcall getc
    ldi atx_framecnt, bytes_per_frame
    ret
    
ATX_ISR:
    cli
    rcall atx_bitset
    reti
    
;***************************************************************************
;***************************************************************************
;***************************************************************************
;*
;* INIT
;*
;* DESCRIPTION
;*	Initialization
;*
;***************************************************************************
;***************************************************************************
;***************************************************************************

INIT:
	ldi	temp1,RAMEND
	out SPL,temp1			; Locate stack
   
	;init_ports				; Initialize ports
	ldi	temp1,0xff	
	out	PORTD,temp1
;	ldi	temp1,0xff
	out	PORTB,temp1
.IF TESTOUT_SYNC
	ldi	temp1, (1<<TXD | 1<<RTS |1 << TEST_PIN);
.ELSE	
	ldi	temp1, (1<<TXD | 1<<RTS);
.ENDIF
	out	UARTDDR,temp1 ; enale uart pins
    
    ldi temp1, (1 << SE) ; enable idle mode
    out MCUCR, temp1
    
	; init UART
	rcall InitUARTBuffer
	ldi	temp1,N				; set baud rate
	out	UBRR,temp1
	ldi	temp1,(1<<TXEN)|(1<<RXEN)|(1 << RXCIE); initialize UART for TX and RX
	out	UCR,temp1

    sbi AODATDDR, AODATA
    sbi AOCLKDDR, AOCLK

	; init airinc transiver
	set_atx_100K
	ldi atx_framecnt, 0xff

    ; prepare timer0 for fast PWM mode, and assign OCR0B for airinc output positive clk
    ldi temp1, (1 << WGM01 | 1<< WGM00 | 1 << COM0B1)
    out TCCR0A, temp1
    ldi temp1, (1 << WGM02)
    out TCCR0B, temp1
    
    in temp1, TIMSK 
    ori temp1, (1 << OCIE0B)
    out TIMSK, temp1
    
    ; Init USI as slave SPI with external positive CLK and enable interrupt on rx complete
    ldi temp1, (1 << USICS1 | 0 << USICS0 | 0 << USICLK | 0 << USIWM1 | 1 << USIWM0 | 1 << USIOIE)
    out USICR, temp1
    
    clr zero
    sei

mainloop:
    sleep
    rjmp mainloop


;**** End of File ****
